% -------------------------------------------------------------------------
% Compute projection coefficients
% -------------------------------------------------------------------------

load SGU_solution.mat

nx = size(hx,1);
ny = size(gx,1);
prefs.ndec = 2;
vlist     = {'DGDP', 'DC',    'DI',    'DN'};
vvidx     = [gy_idx gc_idx  gai_idx   gh_idx];

funds_idx  = [zy_idx,mua_idx,g_idx,mux_idx,muw_idx,zeta_idx,zi_idx];
other_funds_idx = [];

%Drop things
keep_idx = 1:nx;

A = gx(:,keep_idx);
B = hx(keep_idx,keep_idx);
C = eta(keep_idx,:);
D = zeros(size(A));

% Endogenous variables and fundamentals
H = eye(size(B));
H = H([zy_idx,mua_idx,g_idx,mux_idx,muw_idx,zeta_idx,zi_idx]-ny,:);
A = A([gy_idx gc_idx  gai_idx   gh_idx],:);

% Grid for detrending parameter
lam = linspace(0,0.9,10)';

% Outer loop
J  = 1000;
ny = size(A,1);
nx = size(B,1);
ne = size(C,2);
nz = size(H,1);
for i = 1:length(lam);

% Augmented transition matrices    
Alam = [eye(ny),zeros(ny,nx)]; 
Blam = [lam(i).*eye(ny),A;zeros(nx,ny),B];
Clam = [zeros(ny,ne);C];
Hlam = [zeros(nz,ny),H];

% Projection on productivity shocks
[M,Q,K,V] = proj(Alam,Blam,Clam,Hlam,J);

% Current and past fundamental share
pshare = M(:,:,J+1)*V*M(:,:,J+1)';
for j = J+2:2*J+1
    pshare = pshare + M(:,:,j)*V*M(:,:,j)';
end
var_c = Q;
pshares(:,i) = diag(pshare)./diag(var_c);

% Future fundamental share
fshare = 0;
for j = 1:J
    fshare = fshare + M(:,:,j)*V*M(:,:,j)';
end
fshares(:,i) = diag(fshare)./diag(var_c);    
%disp(lam(i));
end

% Save results
save('../info_figure/shares_sgu','pshares','fshares','lam');